program colortst;
uses objects,views,app,drivers,menus,dialogs,

     Color_app; {* <------- *}


type
  Ttest = object(Color_Application)    {* <------ *}
            constructor init;
            procedure InitMenuBar; virtual;
            procedure HandleEvent (var Event:TEvent); virtual;
          end;


{**********************************************************************}
procedure Color_Demo (Background : integer);
var
  Dialog  : COLOR_APP.PColor_Dialog;
  R       : OBJECTS.TRect;
  Control : word;
  Ok_B    : COLOR_APP.PColor_Button;
begin

  R.Assign(0,0,80,23);
  Dialog := New(COLOR_APP.PColor_Dialog,       {* <------- *}
               Init(R,'BUTTON/STATICTEXT COLOR DEMO '));
  WITH Dialog^ DO
  BEGIN
    {Flags := Flags AND NOT VIEWS.wfClose;}

{$IFDEF Ver70}
    {palette := DIALOGS.dpGrayDialog;  {bp7, p332}
    {palette := DIALOGS.dpCyanDialog;  {bp7, p332}
    {palette := DIALOGS.dpBlueDialog;  {bp7, p332}
    Palette := Background;
{$ENDIF}

    R.Assign(1,4,11,8);
    Insert(New(PButton, Init(R,'PButton',VIEWS.cmYes,bfNormal)));

    R.Assign(27,1,45,2);
    Insert(New(PStaticText,Init(R,'Normal StaticText')));

    R.Assign(11,2,34,3);
    Insert(New(PColor_StaticText,Init(R,'Color StaticText Type 1',Button_Red)));

    R.Assign(41,2,64,3);
    Insert(New(PColor_StaticText2,Init(R,'Color StaticText Type 2',Button_Red)));


    R.Assign(11,4,21,8);
    Insert(New(PColor_Button,   {* <--------------- *}
               Init(R,'~B~lack',cmCancel,bfNormal,
                                     Button_Black)));
    R.Assign(21,4,31,8);
    Insert(New(PColor_Button,Init(R,'Bl~u~e',cmOk,bfDefault,
                                     Button_Dk_Blue)));
    R.Assign(31,4,41,8);
    Insert(New(PColor_Button,Init(R,'~G~reen',cmOk,bfDefault,
                                     Button_Green)));
    R.Assign(41,4,51,8);
    Insert(New(PColor_Button,Init(R,'~C~yan',cmOk,bfDefault,
                                     Button_Cyan)));
    R.Assign(51,4,61,8);
    Insert(New(PColor_Button,Init(R,'~R~ed',cmOk,bfDefault,
                                     Button_Red)));
    R.Assign(61,4,71,8);
    Insert(New(PColor_Button,Init(R,'~M~agenta',cmOk,bfDefault,
                                     Button_Purple)));

    R.Assign(1,9,11,13);
    Insert(New(PColor_Button,Init(R,'~B~rown',cmYes,bfNormal,
                                     Button_Brown)));
    R.Assign(11,9,21,13);
    Insert(New(PColor_Button,Init(R,'Lt Gre~y~',cmCancel,bfNormal,
                                     Button_Grey)));
    R.Assign(21,9,31,13);
    Insert(New(PColor_Button,Init(R,'~D~k Grey',cmOk,bfDefault,
                                     Button_Dk_Grey)));
    R.Assign(31,9,41,13);
    Insert(New(PColor_Button,Init(R,'~L~t Blue',cmOk,bfDefault,
                                     Button_Lt_Blue)));
    R.Assign(41,9,51,13);
    Insert(New(PColor_Button,Init(R,'Lt Gre~n~',cmOk,bfDefault,
                                     Button_Lt_Green)));
    R.Assign(51,9,61,13);
    Insert(New(PColor_Button,Init(R,'~L~t Cyan',cmOk,bfDefault,
                                     Button_Lt_Cyan)));
    R.Assign(61,9,71,13);
    Insert(New(PColor_Button,Init(R,'Lt R~e~d',cmOk,bfDefault,
                                     Button_Lt_Red)));

    R.Assign(1,14,11,18);
    Insert(New(PColor_Button,Init(R,'Lt M~a~ge',cmYes,bfNormal,
                                     Button_Lt_Purple)));
    R.Assign(11,14,21,18);
    Insert(New(PColor_Button,Init(R,'Yell~o~w',cmCancel,bfNormal,
                                     Button_Yellow)));
    R.Assign(21,14,31,18);
    Insert(New(PColor_Button,Init(R,'~W~hite',cmOk,bfDefault,
                                     Button_White)));

    R.Assign(31,14,51,18);
    Ok_B := New(PColor_Button,         {* <--------- *}
                  Init(R,'~S~hadowLess',cmYes,bfNormal,
                                     Button_Color_Default));
    Insert(Ok_B);
    Ok_B^.Hide_Shadow;                 {* <--------- *}

  END; {with}

  Control := APP.Desktop^.ExecView(Dialog);

  DISPOSE (Dialog,Done);
end; {color_demo}




const
   cmNow  = 100;
   cmNow1 = 101;
   cmNow2 = 102;

{**************************************************************************}
procedure Push_Event (Cmd : word);
var
  Put_Event : TEvent;
begin
  with Put_Event do
  begin
    What    := evCommand;
    Command := Cmd;
    InfoPtr := nil;
  end; {with}
  {*------------------------------------------------------*}
  {* put it on the Event Schedule Queue                   *}
  {*------------------------------------------------------*}
  DeskTop^.PutEvent (Put_Event);
end; {Push_Event}


{**************************************************************************}
constructor Ttest.Init;
begin
{$IFDEF Ver60}
  Color_Application.Init;
{$ELSE}
  Inherited init;
{$ENDIF}
  Push_Event (cmNow);

end; {init}


{**************************************************************************}
procedure Ttest.InitMenuBar;
var R:TRect;
begin
    GetExtent(R);
    R.B.Y := R.A.Y +1;
    MenuBar:= New(PMenuBar, Init(R, NewMenu(
      NewSubMenu('~S~ee It',hcNoContext, NewMenu(
        NewItem('~S~how Gray Dialog', 'F2', kbF2, cmNow, hcNoContext,
{$IFDEF Ver60}
        nil)),
{$ELSE}
        NewItem('~S~how Blue Dialog', 'F3', kbF3, cmNow1, hcNoContext,
        NewItem('~S~how Cyan Dialog', 'F4', kbF4, cmNow2, hcNoContext,
        nil)))),
{$ENDIF}
        nil)
      )));
end; {initmenubar}


{**************************************************************************}
procedure Ttest.HandleEvent(var Event: TEvent);
var
  dont_care : longint;
begin {HandleEvent}
{$IFDEF Ver60}
  Color_Application.HandleEvent (Event);
{$ELSE}
  inherited HandleEvent(Event);
{$ENDIF}

  case Event.What of
    evCommand:
      begin
        case Event.Command of
          cmNow : Color_Demo (2);
          cmNow1: Color_Demo (0);  {* BP 7.0 *}
          cmNow2: Color_Demo (1);  {* BP 7.0 *}
        else
          Exit;
        end;
        ClearEvent(Event);
      end;
  end;
 end; {HandleEvent}

{***********************************************************************}
var
  test: Ttest;

begin
  test.init;
  test.run;
  test.done;
end. {end colortst}

